#!/usr/bin/env python

# Note: This is not a standard distutils setup.py file. Its only purpose is to
# make sure that resource (.qrc) and user interface (.ui) files are compiled
# before the presentation or examples are run.

import os, sys

qrc_files = [
    ("Examples", "XMLPatterns", "symbols.qrc"),
    ("Examples", "Device_Examples", "photos", "extra_photos.qrc")
    ]

ui_files = []

if __name__ == "__main__":

    this_path = os.path.split(__file__)[0]
    
    for qrc in qrc_files:
    
        qrc_pieces = (this_path,) + qrc
        qrc_path = os.path.join(*qrc_pieces)
        
        py_pieces = qrc_pieces[:-1] + (qrc_pieces[-1][:-4]+"_rc.py",)
        py_path = os.path.join(*py_pieces)
        
        if os.system("pyrcc4 -py2 -o "+py_path+" "+qrc_path):
            sys.stderr.write("Failed to create the resource file for '%s' to create '%s'.\n" % (qrc_path, py_path))
            sys.stderr.write("You may wish to try running pyrcc4 manually on the file.\n")
        else:
            print "Created '%s'." % py_path
    
    for ui in ui_files:
    
        ui_pieces = (this_path,) + ui
        ui_path = os.path.join(*ui_pieces)
        
        py_pieces = ui_pieces[:-1] + (ui_pieces[-1][:-4]+"_rc.py",)
        py_path = os.path.join(*py_pieces)
        
        if os.system("pyuic4 -o "+py_path+" "+ui_path):
            sys.stderr.write("Failed to create the user interface file for '%s' to create '%s'.\n" % (ui_path, py_path))
            sys.stderr.write("You may wish to try running pyuic4 manually on the file.\n")
        else:
            print "Created '%s'." % py_path
    
    sys.exit()
